#!/usr/bin/python pseudoserver.py
#psmodule.py
# module base
# written by radicand

L_IN = 1
L_OUT = 2
L_STATUS = 4
L_SECURITY = 8
L_DEBUG = 16
L_SQL = 32
L_COMMAND = 64
L_ERROR = 128

class PSModule(object):
	VERSION = 1
	
	parent = None
	logchan = ""
	logger = None
	config = None
	dbp = None
	debug = 0
	use_uid = True
	
	def __init__(self, parent, config):
		self.parent = parent
		self.use_uid = self.parent.use_uid
		self.config = config
		self.logchan = config.get('control', 'channel')
		self.logger = parent.logger
		self.dbp = parent.dbx.cursor()
		self.debug = self.config.getint('control', 'debug')
		self.started = False
		
	def reload(self):
		self.config.read("config.ini")
		self.debug = self.config.getint('control', 'debug')
	
	def startup(self):
		if self.started: return False
		self.started = True
		return True
	
	def shutdown(self):
		if not self.started: return
	
	def getVersion(self):
		return self.VERSION

	def getCommands(self):
		return ()
			
	def getHooks(self):
		return ()
		
